﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IGCheckboxTree
{
    public class SetupChangesVM : NotificationObject
    {
        #region Constructor

        public SetupChangesVM()
        {
            AllItems = new ObservableCollection<Item>();
            AllItems = DoDifferences();
        }

        #endregion

        #region Properties

        private ObservableCollection<Item> _allItems;
        /// <summary>
        /// The main object we are binding to, the overall collection of objects containing objects containing changes etc
        /// </summary>
        public ObservableCollection<Item> AllItems
        {
            get { return _allItems; }
            set
            {
                if (_allItems != value)
                {
                    _allItems = value;
                    FirePropertyChanged(()=>AllItems);
                }
            }
        }

        #endregion

        #region Methods

        private ObservableCollection<Item> DoDifferences()
        {
            Item root = new Item("All Billing Types", false, false)
            {
                //IsInitiallySelected = true,
                Children =
                {
                    new Item("Client Billing", true, false)
                    {
                        Children =
                        {
                            new Item("Active Participants", false, false)
                            {
                                Children=
                                {
                                    new Item("Flossmoor", true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Contact Info", true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Telephone Number", true, false)
                                                    {
                                                        Children=
                                                        {
                                                            new Item("Extension changed from 1234 to 5555", true, true)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            new Item("Eligible Employees", false, false)
                            {
                                Children=
                                {
                                    new Item("Alachua", true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Rate", true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Rate changed from 5.73 to 6.00",true, true),
                                                    new Item("Billing Frequency changed from Semi-Annually to Monthly",true, false)
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            new Item("Flat Rate", false, false)
                            {
                                Children=
                                {
                                    new Item("Alaska",true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Rate",true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Billing Frequency changed from Semi-Annually to Monthly",true, true)
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            new Item("Plan Participants", false, false)
                            {
                                Children=
                                {
                                    new Item("Detroit",true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Rate",true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Rate changed from 1.00 to 1.73",true, false)
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                        }
                    }
                    ,
                    new Item("Vendor Billing", false, false)
                    {
                        Children =
                        {
                            new Item("Active Contributors", false, false)
                            {
                            Children=
                                {
                                    new Item("AXA",true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Contact Info",true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Telephone Number",true, false)
                                                    {
                                                        Children=
                                                        {
                                                            new Item("Changed from 333-4444 to 555-2222",true, false)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                            new Item("Plan Participant", false, false)   
                            {
                            Children=
                                {
                                    new Item("VALIC",true, false)
                                    {
                                        Children=
                                        {
                                            new Item("Clients",true, false)
                                            {
                                                Children=
                                                {
                                                    new Item("Alachua",true, false)
                                                    {
                                                        Children=
                                                        {
                                                            new Item("Rate",true, false)
                                                            {
                                                                Children=
                                                                {
                                                                    new Item("Rate changed from 5.50 to 5.73",true, true),
                                                                    new Item("Some very long description here to test the text wrapping in the name column.  No difference should be this legnthy anyway...",true, true)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            },
                        }
                    },
                }
            };

            //for (int j = 0; j < 1100; j++)
            //    root.Children[0].Children.Add(new Item("Something", true, true));


            //root.Children[0].IsChecked = true;
            root.Initialize();
            return new ObservableCollection<Item> { root };
        }

        #endregion
    }
}
